



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>HDFS读写数据块--${dfs.data.dir}选择策略</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">HDFS读写数据块--${dfs.data.dir}选择策略</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-15 23:13:33 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>　　最近工作需要，看了HDFS读写数据块这部分。不过可能跟网上大部分帖子不一样，本文主要写了${dfs.data.dir}的选择策略，也就是block在DataNode上的放置策略。我主要是从我们工作需要的角度来读这部分代码的。　　</p>
<div>
<pre class="prettyprint linenums"> hdfs-site.xml<br />
 &lt;property&gt;<br />
   &lt;name&gt;dfs.data.dir&lt;/name&gt;<br />
   &lt;value&gt;/mnt/datadir1/data,/mnt/datadir2/data,/mnt/datadir3/data&lt;/value&gt;<br />
 &lt;/property&gt;</pre>
</div>
<p>　　所谓${dfs.data.dir}的选择策略，就是当DataNode配置有多个${dfs.data.dir}目录时(如上面的配置)，该选择哪个目录来存放block。一般多个硬盘分别挂载到不同的${dfs.data.dir}下，所以存储block是要决定block该放到哪个磁盘上。</p>
<p>　　创建文件总共有两步：</p>
<p>　　1、在写block之前，需要与NameNode通信来生成文件(INodeFile、INodeFileUnderConstruction)。首先在DFSClient端的create()方法中发起写请求，然后通过RPC由NameNode最终调用FSNameSystem的startFileInternal()方法来创建文件。</p>
<div>
<div>
<pre class="prettyprint linenums">   private void startFileInternal(String src,<br />
                                               PermissionStatus permissions,<br />
                                               String holder,<br />
                                               String clientMachine,<br />
                                               boolean overwrite,<br />
                                               boolean append,<br />
                                               boolean createParent,<br />
                                               short replication,<br />
                                               long blockSize<br />
                                               ) throws IOException {<br />
     if (NameNode.stateChangeLog.isDebugEnabled()) {<br />
       NameNode.stateChangeLog.debug("DIR* startFile: src=" + src<br />
           + ", holder=" + holder<br />
           + ", clientMachine=" + clientMachine<br />
           + ", createParent=" + createParent<br />
           + ", replication=" + replication<br />
           + ", overwrite=" + overwrite<br />
           + ", append=" + append);<br />
     }

     FSPermissionChecker pc = getPermissionChecker();<br />
     synchronized (this) {<br />
       if (isInSafeMode())<br />
         throw new SafeModeException("Cannot create " + src, safeMode);<br />
       if (!DFSUtil.isValidName(src)) {<br />
         throw new IOException("Invalid name: " + src);<br />
       }

       // Verify that the destination does not exist as a directory already.<br />
       boolean pathExists = dir.exists(src);<br />
       if (pathExists &amp;&amp; dir.isDir(src)) {<br />
         throw new IOException("Cannot create "+ src + "; already exists as a directory");<br />
       }

       if (isPermissionEnabled) {<br />
         if (append || (overwrite &amp;&amp; pathExists)) {<br />
           checkPathAccess(pc, src, FsAction.WRITE);<br />
         } else {<br />
           checkAncestorAccess(pc, src, FsAction.WRITE);<br />
         }<br />
       }

       if (!createParent) {<br />
         verifyParentDir(src);<br />
       }

       try {<br />
         INode myFile = dir.getFileINode(src); //根据路径寻找该文件<br />
         recoverLeaseInternal(myFile, src, holder, clientMachine, false);

         try {<br />
           verifyReplication(src, replication, clientMachine);<br />
         } catch (IOException e) {<br />
           throw new IOException("failed to create " + e.getMessage());<br />
         }<br />
         if (append) {//若是追加操作<br />
           if (myFile == null) {<br />
             throw new FileNotFoundException("failed to append to non-existent "<br />
                 + src + " on client " + clientMachine);<br />
           } else if (myFile.isDirectory()) {<br />
             throw new IOException("failed to append to directory " + src<br />
                 + " on client " + clientMachine);<br />
           }<br />
         } else if (!dir.isValidToCreate(src)) {<br />
           if (overwrite) {//允许覆盖原来的文件<br />
             delete(src, true);<br />
           } else {<br />
             throw new IOException("failed to create file " + src<br />
                 + " on client " + clientMachine<br />
                 + " either because the filename is invalid or the file exists");<br />
           }<br />
         }

         DatanodeDescriptor clientNode = host2DataNodeMap<br />
             .getDatanodeByHost(clientMachine);

         if (append) {<br />
           //<br />
           // Replace current node with a INodeUnderConstruction.<br />
           // Recreate in-memory lease record.<br />
           //<br />
           INodeFile node = (INodeFile) myFile;<br />
           INodeFileUnderConstruction cons = new INodeFileUnderConstruction(<br />
               node.getLocalNameBytes(), node.getReplication(),<br />
               node.getModificationTime(), node.getPreferredBlockSize(),<br />
               node.getBlocks(), node.getPermissionStatus(), holder,<br />
               clientMachine, clientNode);<br />
           dir.replaceNode(src, node, cons);<br />
           leaseManager.addLease(cons.clientName, src);

         } else {<br />
           // Now we can add the name to the filesystem. This file has no<br />
           // blocks associated with it.<br />
           //<br />
           checkFsObjectLimit();

           // increment global generation stamp<br />
           long genstamp = nextGenerationStamp();<br />
           INodeFileUnderConstruction newNode = dir.addFile(src, permissions,<br />
               replication, blockSize, holder, clientMachine, clientNode,<br />
               genstamp);<br />
           if (newNode == null) {<br />
             throw new IOException("DIR* startFile: Unable to add to namespace");<br />
           }<br />
           leaseManager.addLease(newNode.clientName, src);<br />
           if (NameNode.stateChangeLog.isDebugEnabled()) {<br />
             NameNode.stateChangeLog.debug("DIR* startFile: "<br />
                                        +"add "+src+" to namespace for "+holder);<br />
           }<br />
         }<br />
       } catch (IOException ie) {<br />
         NameNode.stateChangeLog.warn("DIR* startFile: "<br />
                                      +ie.getMessage());<br />
         throw ie;<br />
       }<br />
     }<br />
   }</pre>
</div>
<p>startFileInternal()</p></div>
<p>　　该方法的主要内容如下：</p>
<p>　　1）首先做一些检查(安全模式、权限、该路径是否已经以文件夹形式存在等)</p>
<p>　　2）若不是追加操作：</p>
<p>　　生成generation stamp(针对每个文件生成一个)；并构造INodeFileUnderConstruction对象(preferredBlockSize)；将这个文件添加到filesystem；添加租约(即有时间限制的写锁)；</p>
<p>若是追加操作：</p>
<p>　　将src下的INodeFile替换成INodeFileUnderConstruction；添加租约；</p>
<p>　　2、在NameNode端生成文件之后，client向NameNode申请block，并将其写入到DataNode。在上面的工作完成后，就启动DataStreamer线程来向DataNode中写入block。整个流程如下：</p>
<p>　　1）一些前期检查</p>
<p>　　2）向NameNode申请block(与NameNode有一次通信)</p>
<p>　　 &nbsp;a. 根据副本放置策略，选择N个DataNode作为block的放置位置；</p>
<p>　　 &nbsp;b. 随机生成一个不重复的blockID；</p>
<p>　　 &nbsp;c. 把该block添加到对应的文件；</p>
<p>　　3）将目标DN组织成pipeline，并向第一个DN发送Packet</p>
<p>　　选择其中几个比较重要的方法分析下：</p>
<div>
<div>
<pre class="prettyprint linenums">  /**<br />
    * The client would like to obtain an additional block for the indicated<br />
    * filename (which is being written-to).  Return an array that consists<br />
    * of the block, plus a set of machines.  The first on this list should<br />
    * be where the client writes data.  Subsequent items in the list must<br />
    * be provided in the connection to the first datanode.<br />
    *<br />
    * Make sure the previous blocks have been reported by datanodes and<br />
    * are replicated.  Will return an empty 2-elt array if we want the<br />
    * client to "try again later".<br />
    */<br />
   //向NameNode申请block<br />
   public LocatedBlock getAdditionalBlock(String src,<br />
                                          String clientName,<br />
                                          HashMap&lt;Node, Node&gt; excludedNodes<br />
                                          ) throws IOException {<br />
     long fileLength, blockSize;<br />
     int replication;<br />
     DatanodeDescriptor clientNode = null;<br />
     Block newBlock = null;

     NameNode.stateChangeLog.debug("BLOCK* getAdditionalBlock: "<br />
                                   +src+" for "+clientName);

     synchronized (this) {<br />
       if (isInSafeMode()) {//check safemode first for failing-fast<br />
         throw new SafeModeException("Cannot add block to " + src, safeMode);<br />
       }<br />
       // have we exceeded the configured limit of fs objects.<br />
       checkFsObjectLimit();

       INodeFileUnderConstruction pendingFile  = checkLease(src, clientName);

       //<br />
       // If we fail this, bad things happen!<br />
       //<br />
       if (!checkFileProgress(pendingFile, false)) {<br />
         throw new NotReplicatedYetException("Not replicated yet:" + src);<br />
       }<br />
       fileLength = pendingFile.computeContentSummary().getLength();<br />
       blockSize = pendingFile.getPreferredBlockSize();<br />
       clientNode = pendingFile.getClientNode();<br />
       replication = (int)pendingFile.getReplication();<br />
     }

     // choose targets for the new block to be allocated.<br />
     //选择副本存放的位置<br />
     DatanodeDescriptor targets[] = replicator.chooseTarget(src,<br />
                                                            replication,<br />
                                                            clientNode,<br />
                                                            excludedNodes,<br />
                                                            blockSize);<br />
     if (targets.length &lt; this.minReplication) {<br />
       throw new IOException("File " + src + " could only be replicated to " +<br />
                             targets.length + " nodes, instead of " +<br />
                             minReplication);<br />
     }

     // Allocate a new block and record it in the INode.<br />
     synchronized (this) {<br />
       if (isInSafeMode()) { //make sure it is not in safemode again.<br />
         throw new SafeModeException("Cannot add block to " + src, safeMode);<br />
       }<br />
       INode[] pathINodes = dir.getExistingPathINodes(src);<br />
       int inodesLen = pathINodes.length;<br />
       checkLease(src, clientName, pathINodes[inodesLen-1]);<br />
       INodeFileUnderConstruction pendingFile  = (INodeFileUnderConstruction)<br />
                                                 pathINodes[inodesLen - 1];

       if (!checkFileProgress(pendingFile, false)) {<br />
         throw new NotReplicatedYetException("Not replicated yet:" + src);<br />
       }

       // allocate new block record block locations in INode.<br />
       //分配block，并随机生成一个不重复的blockID，然后在INode中记录该block<br />
       newBlock = allocateBlock(src, pathINodes);<br />
       pendingFile.setTargets(targets);

       for (DatanodeDescriptor dn : targets) {<br />
         dn.incBlocksScheduled();<br />
       }<br />
       dir.persistBlocks(src, pendingFile);<br />
     }<br />
     if (persistBlocks) {<br />
       getEditLog().logSync();<br />
     }

     // Create next block<br />
     LocatedBlock b = new LocatedBlock(newBlock, targets, fileLength);<br />
     if (isAccessTokenEnabled) {<br />
       b.setBlockToken(accessTokenHandler.generateToken(b.getBlock(),<br />
           EnumSet.of(BlockTokenSecretManager.AccessMode.WRITE)));<br />
     }<br />
     return b;<br />
   }</pre>
</div>
<p>getAdditionalBlock</p></div>
<p>　　上面的方法还涉及到了块的选择策略，这个留在下一篇再说。下面这个图来总结下上面方法的调用层次：</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/676214/201411/262015400125972.jpg" /></p>
<p>　　最后重点说一下block在DataNode上的存储策略。其调度层次如下：</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/676214/201411/262031520748836.jpg" /></p>
<p>　　首先说一下其中涉及到的数据结构：</p>
<div>
<pre class="prettyprint linenums">  class FSVolume {    //卷信息,代表${dfs.data.dir}<br />
     private File currentDir;      //存放block，即${dfs.data.dir}/current<br />
     private FSDir dataDir;        //表示currentDir有哪些块文件<br />
     private File tmpDir;          //存放一些临时文件，即${dfs.data.dir}/tmp<br />
     private File blocksBeingWritten;    //放置正在写的block，即${dfs.data.dir}/ blocksBeingWritten<br />
     private File detachDir;       //是否写分离，即${dfs.data.dir}/detach<br />
     private DF usage;<br />
     private DU dfsUsage;<br />
     private long reserved;</pre>
</div>
<div>
<pre class="prettyprint linenums">   static class FSVolumeSet {  //卷信息集合,代表多个${dfs.data.dir}<br />
     FSVolume[] volumes = null;    //代表多个FSVolume，并将其组织成一个数组<br />
     int curVolume = 0;            //指示当前正在使用哪一个FSVolume  </pre>
</div>
<p>　　FSVolumeSet 代表多个${dfs.data.dir}目录的集合，它将这些目录组织成一个数组volumes，然后用curVolume来指示当前正在使用的是哪个${dfs.data.dir}目录。${dfs.data.dir}的选择策略如下：</p>
<p>　　当有多个${dfs.data.dir}时，DataNode顺序地从volumes选择一个FSVolume用来存放block(先放在blocksBeingWritten目录下，写完后再转移到current目录下)；</p>
<p>　　每次写完一个block， curVolume增1。以此实现多个${dfs.data.dir}目录的轮流写。该策略在FSDataSet.FSVolumeSet的getNextVolume()方法中实现。</p>
<div>
<pre class="prettyprint linenums">    synchronized FSVolume getNextVolume(long blockSize) throws IOException {

       if(volumes.length &lt; 1) {<br />
         throw new DiskOutOfSpaceException("No more available volumes");<br />
       }

       // since volumes could've been removed because of the failure<br />
       // make sure we are not out of bounds<br />
       if(curVolume &gt;= volumes.length) {<br />
         curVolume = 0;<br />
       }

       int startVolume = curVolume;

       while (true) {<br />
         FSVolume volume = volumes[curVolume];<br />
         curVolume = (curVolume + 1) % volumes.length;    //增1<br />
         if (volume.getAvailable() &gt; blockSize) { return volume; }<br />
         if (curVolume == startVolume) {<br />
           throw new DiskOutOfSpaceException("Insufficient space for an additional block");<br />
         }<br />
       }<br />
     }</pre>
</div>
<p>　　接着来说一下读block的过程。在Map Task执行时，nextKeyValue()方法来从block中读取数据，主要步骤如下：</p>
<p>　　1、根据创建Map Task时指定的文件偏移量和长度，来确定应该读取哪个block，并获取这个block的详细信息。(与NameNode有一次通信)。</p>
<p>　　2、根据block所在的DataNode，选择一个最好的DN，并建立与该DN的socket连接(默认不启用本地读)。</p>
<p>　　其方法的调用层次如下：</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/676214/201412/012035276551315.jpg" /></p>
<p>　　Map Task读取数据是由RecordReader类来完成的。它是个接口，有两个子类：</p>
<p>BlockReaderLocal：读取本地block(不通过DataNode)</p>
<p>RemoteBlockReader：读取远程block(通过DataNode)</p>
<p>　　Map Task在读取数据时，即使是本地数据也是使用RemoteBlockReader来读的，也就是通过socket，默认不开启本地读。通过这个链接的方法可以开启本地读(<a href="http://hadoop.apache.org/docs/current/hadoop-project-dist/hadoop-hdfs/ShortCircuitLocalReads.html" rel="external nofollow noreferrer">http://hadoop.apache.org/docs/current/hadoop-project-dist/hadoop-hdfs/ShortCircuitLocalReads.html</a>)，也就是使用BlockReaderLocal直接来从本地读block，而不通过DataNode。以下的分析都是基于BlockReaderLocal来完成的。</p>
<p>先说一下涉及到的数据结构：</p>
<div>
<pre class="prettyprint linenums"> public class BlockLocalPathInfo implements Writable {    //用来描述block的位置信息

   private Block block;                  //特定的块文件<br />
   private String localBlockPath = "";   //块文件的本地存储路径<br />
   private String localMetaPath = "";    //块校验文件的本地存储路径</pre>
</div>
<div>
<pre class="prettyprint linenums">  //Stores the cache and proxy for a local datanode.<br />
   private static class LocalDatanodeInfo {    //代表本机上的某个DataNode(一个机器上可能运行多个DataNode)<br />
   private final Map&lt;Block, BlockLocalPathInfo&gt; cache;    //其中维护的表(block--&gt;block位置信息)</pre>
</div>
<div>
<pre class="prettyprint linenums">   // Multiple datanodes could be running on the local machine. Store proxies in<br />
   // a map keyed by the ipc port of the datanode.<br />
   //BlockReaderLocal中维护的表：<br />
   private static Map&lt;Integer, LocalDatanodeInfo&gt; localDatanodeInfoMap = new HashMap&lt;Integer, LocalDatanodeInfo&gt;();<br />
    // Integer：表示端口号<br />
    //  LocalDatanodeInfo：表示某个DataNode</pre>
</div>
<div>
<pre class="prettyprint linenums"> /**<br />
  * This class is used by the datanode to maintain the map from a block<br />
  * to its metadata.<br />
  */<br />
 class DatanodeBlockInfo {    //表示该DN上的所有block信息(block--&gt;block元信息)

   private FSVolume volume;       //block所在的FSVolume<br />
   private File     file;         // block file<br />
   private boolean detached;      // block的写复制是否完成</pre>
</div>
<div>
<pre class="prettyprint linenums">  //block与block元信息映射表<br />
  HashMap&lt;Block,DatanodeBlockInfo&gt; volumeMap = new HashMap&lt;Block, DatanodeBlockInfo&gt;();;</pre>
</div>
<p>　　在读block时，首先根据localDatanodeInfoMap确定要访问的DataNode；然后从volumeMap中找到block对应的DatanodeBlockInfo信息(这其中就包括block对应的FSVolume，这是在存储block时确定的。本文前边有写)；然后根据DatanodeBlockInfo来构造BlockLocalPathInfo对象，将block的相关信息存放到BlockLocalPathInfo对象中。最后BlockReaderLocal根据BlockLocalPathInfo对象来读取相应的block。&nbsp;具体在BlockReaderLocal.newBlockReader()方法中。</p>
<p>　　本文基于hadoop1.2.1</p>
<p>　　如有错误，还请指正</p>
<p><strong>　　转载请注明出处：<a href="http://www.cnblogs.com/gwgyk/p/4124038.html" rel="external nofollow noreferrer">http://www.cnblogs.com/gwgyk/p/4124038.html</a></strong></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/j3906m9d.html">分享一个SQLSERVER脚本（计算数据库中各个表的数据量和每行记录所占用空间）</a>
		</li>
						<li><a href="https://www.batexi.com/a/495gr1mq.html">CentOS6&period;5安装Eclipse</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8e4p2m9.html">怎么用SAX生成xml文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/m967e2n8.html">CSS的应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8ejkrx9.html">maven3&period;2&period;3&plus;eclipse4&period;4&plus;JDK1&period;8&plus;win8&period;1&lowbar;64bit环境搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxye3e9.html">Webservice接口</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2g72l8.html">Nginx反向代理搭建配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qn4vj28.html">android studio 使用gradle 导出jar包，并打包assets目录</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xoj7n9.html">救火必备linux命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnd5prq.html">selenium支付高版本的FireFox</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxno6vd8.html">ubuntu 错误 &amp;amp&semi; 解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o5rj39.html">spring IOC经典理解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyde27xq.html">散列表的实现 -- 数据结构与算法的javascript描述 第八章</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m73lm8.html">DHTMLX系列组件的学习笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojdkklq.html">Unity3D 回合制 网上源码 目前还在研究构思</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gezd148.html">Tomcat利用Redis存储Session</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j6rkl8.html">sql server存储过程实现批量删除</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pkp448.html">css为第几个倍数元素添加样式</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pwdgy8.html">Linux内核中断和异常分析&lpar;下&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyy5vedq.html">Linux下MySQL 安装配置</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/5qy4pegq.html">Oracle 截取字符串</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8e5p4z8.html">Unity手撸2048小游戏&mdash;&mdash;模块拆分</a>
			</li>
						<li><a href="https://www.batexi.com/a/m965oxnq.html">java基本数据类型的字面量</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdop778.html">&lbrack;linux&rsqb; scp无密码拷贝</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqv0e7o8.html">log4jWARN Please initialize the log4j system properly解决办法</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jpegl9.html">Asp&period;Net&lowbar;&amp;lt&semi;&percnt;&percnt;&amp;gt&semi;模式常用语法</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8eoo5kq.html">python3 装饰器</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqv00oo8.html">在linux上部署web环境</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qw001k9.html">H5离线存储</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qw0rkk9.html">利用Babel来转化你的ES2015脚本初步</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
